/*
Licensed Materials - Property of IBM
5725-C95
Copyright IBM Corporation 2012. All Rights Reserved.
US Government Users Restricted Rights- Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

// Mainly for the communication with Portal.

define(["dojo/_base/json", "./logger"], function(json, logger) {
				
	var broadcastHelper = new Object();
	
	/*
	 event:				the object to broadcast
	 target(optional):	If not provided, use "*" as targetOrigin and parent window (if exists) as target window.
						If provided, target object is expected to have property "window" and "origin".	 
	 
	 Implementation remark - use window.postMessage for now. Browser Hash is a candidate solution if postMessage doesn't satisfy the security requirement.
	*/
	broadcastHelper.broadcastMessage = function(event, target) {
		var targetWindow = broadcastHelper.parentWindow;
		var targetOrigin = "*";
		
		if(!!target) {
			if(!!target.window) {
				targetWindow = target.window; 
			}
			if(!!target.origin) {
				targetOrigin = target.origin; 
			}
		}
		
		if(!!targetWindow) {
			var serializedEvent = json.toJson(event);
			// work item 131966
			try {
				targetWindow.postMessage(serializedEvent, targetOrigin);
			} catch (e) {
				// postMessage() failed, use direct call onMessage instead with faked event. Container MUST be co-located
				logger.log("broadcastHelper", "broadcastMessage", "iframe postMessage() failed, call onMessage() directly - event=" + serializedEvent, logger.FINE);
				if (!!targetWindow.onMessage && typeof targetWindow.onMessage === 'function') {
					targetWindow.onMessage({origin: window.location.protocol + "//" + window.location.host,
											data: serializedEvent, 
											source: window});
				} else {
					logger.log("broadcastHelper", "broadcastMessage", "onMessage() does not exist", logger.FINE);				
				}
			}			
		}
	}
	
	broadcastHelper.parentWindow = (!!window.parent &&  window.parent != window)? window.parent : null;

	return broadcastHelper;
});
