/*
Licensed Materials - Property of IBM
5725-C95
 Copyright IBM Corporation 2012. All Rights Reserved.
US Government Users Restricted Rights- Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

// logger js
define(["require", "dojo/_base/lang", "dojo/has"], function(require, lang, has) { 
	// logger start
	var logger = new Object();
	
	logger.debugComp = {};
	logger.components = null;
	
	logger.INFO = "INFO";
	logger.FINE = "FINE"; 
	logger.FINER = "FINER";

	logger.init = function() {
		//get log details from session
		logger.components = new RegExp("coachDebugTrace=([^&#]*)").exec(window.location.href);
		if (logger.components != null && logger.components != "") {
			logger.components = unescape(logger.components[1]);
			var compArray = logger.components.split(";");
			if (compArray != null && compArray.length != 0) {
				for (var i=0; i<compArray.length; i++) {
					var level = compArray[i].split(":");
					if (level != null && level.length >1) {
						logger.debugComp[level[0]] = level[1];
					} else {
						logger.debugComp[compArray[i]] = logger.FINE;
					}
				}
			}
		} else {
			logger.components = "";
		}
		
	}

	logger.log = function (comp, funct, message, level) {
	
		if (level == undefined) {
			level = logger.FINE;
		}
		var allComponents = !!logger.debugComp["*"];
		
		if (allComponents && logger.debugComp[comp] == undefined) {
			//"*" selected so turn on all tracing
		    if (logger.debugComp["*"] == logger.FINER ||
		    	(level == logger.FINE && (logger.debugComp["*"].indexOf(logger.FINE) != -1)) ||
		    	(level == logger.INFO && ((logger.debugComp["*"] == logger.INFO) || (logger.debugComp["*"].indexOf(logger.FINE) != -1))))  {
		    	if (has("ie") <=8 || has("safari") > 0) {
					console.log(comp + "." + funct + "():" + message);
		    	} else if (lang.isArray(message)) {
		    		message.unshift(comp + "." + funct + "(): ");
		    		console.log.apply(this,message);
		    	}else {
					console.log(comp + "." + funct + "():", message);		    		
		    	}
		    }
		} else if (!!logger.debugComp[comp]) {
			//check specific component
		    if (logger.debugComp[comp] == logger.FINER  ||
		    	(level == logger.FINE && (logger.debugComp[comp].indexOf(logger.FINE) != -1)) ||
		    	(level == logger.INFO && ((logger.debugComp[comp] == logger.INFO) || (logger.debugComp[comp].indexOf(logger.FINE) != -1))))  {
                if (has("ie") <=8 || has("safari") > 0) {
					console.log(comp + "." + funct + "():" + message);
                }else if (lang.isArray(message)) {
		    		message.unshift(comp + "." + funct + "(): ");
		    		console.log.apply(this,message);
		    	}else {
					console.log(comp + "." + funct + "():", message);		    		
		    	}
		    }
		}
	}

	logger.destroy = function() {
	}

	// logger end
	
	return logger;
});
