/*
 * Copyright (C) 2006 Lombardi Software
 * http://www.lombardi.com/
 * All rights reserved.
 *
 * This software is the confidential and proprietary information of Lombardi
 * Software ("Confidential Information"). You shall not disclose such 
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement and/or Non-Disclosure Agreement you entered into 
 * with Lombardi Software. No rights or licenses are granted with respect to
 * the Confidential Information except as expressly set forth in such License
 * Agreement and/or Non-Disclosure Agreement. 
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL LOMBARDI
 * SOFTWARE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * JavaScript file, contains code of JavaScript util functions, needed for 
 * Document Attachment Control.
 * 
 * Created by Sergey Rassokhin, 9/3/2007 
 */

function setVisible(elem, cond) {
	elem.style.display = cond ? "" : "none";	
} 


/* Util function. Creates TD element with given inner HTML content. */
function createTD(text) {
	var td = document.createElement("td");
	td.innerHTML = text;
	return td;	
}

/* Util function. Creates <input/> element with given parameters. */
function createInput(type, name, value) {
	var input = document.createElement("input");
	input.type = type;
	input.value = value;
	input.name = name;
	return input;
}

/* Util function. Creates button element with given caption. */
function createButton(text) {
	var button = document.createElement("input");
	button.type = "button";
	button.value = text;
        button.className = "docAttachmentButton"
	return button;	
}

/* Util function. Creates button element with given caption and click handler. */
function createButton1(text, onclickHandler) {
	var button = createButton(text);
	button.onclick = onclickHandler;
	button.className = "button";
	return button;	
}

/* 
 * Util function. Creates <option/> element with given value, text and selected 
 * state. 
 */
function createOption(text, value, selected) {
	var option = document.createElement("option");
	option.value = value;
	if (selected) {
		option.selected = "selected";
	}
	option.innerHTML = text;
	return option;	
}

/* Util function. Creates <a/> element with given HREF and text. */
function createDownloadLink(doc) {
	var a = document.createElement("a");
	a.href = window._BPM_portalContextRoot + "/jsp/downloadDocument.do?docId=" + doc.id;	
	a.appendChild(document.createTextNode(doc.name));
	return a;
}

/**
 * Returns unique name for new Document Attachment control at the current page.
 */
function getUniqueControlId() {
	var index = 0;
	var cont = true; 
	while (cont) {
		if (window["control" + index] != null) {
			index++;
		} else {
			cont = false;			
		}
	}
	return "control" + index;
}

/**
 * Function refreshes all Document Attachment controls.
 */
function refreshControls() {
	var index = 0;
	var cont = true; 
	while (cont) {
		var ctrl = window["control" + index];
		if (ctrl != null) {
			ctrl.loadDocuments();
			index++;						
		} else {
			cont = false;			
		}
	}	
}
 
