// Our object for the list entries
function ListEntry(type, value ,fullName) {
 this.type = type;
 this.value = value;
 this.fullName = fullName;
}

function compareEntry(a, b) {
 var na = a.value.toLowerCase();
 var nb = b.value.toLowerCase();
 var ina = na.indexOf('\\');
 var inb = nb.indexOf('\\');

 if (ina != -1)
  na = na.substring(ina+1);
 if (inb != -1)
  nb = nb.substring(inb+1);
 if (na < nb)
  return -1;
 else if (na > nb)
  return 1
 else
  return 0;
}

function add2Array(array, entry) {
  array[array.length] = entry;
}

function exists(searchValue, searchObj) {

 var i = 0;
 var found = false;
 for(i = 0; i < searchObj.options.length; i++) {
  if (searchValue.toUpperCase() == searchObj.options[i].value.toUpperCase()) {
   found = true;
   break;
  }
 }
 return found;
}

function doAdd(obj) {
 var from = document.userselect.userselect_list;
 var to   = document.userselect.userselected_list;
 document.userselect.addB.disabled = true;
 for(i=0;i<from.options.length;i++){
  if (from.options[i].selected &&  i >= 0) {
   var text = from.options[i].text;
   var value = from.options[i].value;
   // Lets see if this entry has been added already
   var found = exists(from.options[i].value, to);
   if (!found) {
    to.options[to.options.length] = new Option(text, value);
   }
  }
 }
 for(k=0;k<from.options.length;k++){
  from.options[k].selected = false;
 }
  return false;
}

function doRemove() {
 var to = document.userselect.userselected_list;
 document.userselect.removeB.disabled = true;
 for(i = (to.options.length - 1);i >= 0; i--){
  if (to.options[i].selected && i >= 0) {
    to.options[i] = null;
  }
 }
for(j = (to.options.length - 1);j >= 0; j--){
to.options[j].selected = false;
}
  return false;
}

function trim(str) {
  return str.replace(/^\s*/, '').replace(/\s*$/, '');
}

function findName(usrName){
	for(i=0;i<arrayAll.length;i++){
		if(arrayAll[i].value.toUpperCase() == usrName.toUpperCase()){
			return arrayAll[i].fullName;
		}
	}
}

function findType(usrName){
	for(i=0;i<arrayAll.length;i++){
		if(arrayAll[i].value.toUpperCase() == usrName.toUpperCase()){
			return arrayAll[i].type;
		}
	}
}

function doAddEmail() {
 var to = document.userselect.userselected_list;
 var text = trim(document.userselect.email.value);
 document.userselect.copytoB.disabled = true;
 if (text != "") {
  document.userselect.email.value = "";
  var value = "MAIL:" + text;
  var found = exists(value, to);
  if (!found)
   to.options[to.options.length] = new Option(text, value);
 }
}


function doOK() {
 var recipList = "";
 var to = document.userselect.userselected_list;
 for(i = 0; i < to.options.length; i++) {
  recipList += to.options[i].value;
  if (i < (to.options.length - 1)) recipList += ";";
 }
 var target = opener.document.getElementById("SendTo");
 target.value = recipList;
 window.close();
 return false;
}

function doCancel() {
 window.close();
}

function clearOptions(obj) {
 for(i = (obj.options.length - 1); i >= 0; i--)
  obj.options[i] = null;
}

function processCurrentList(curList) {

 var from = document.userselect.userselect_list;
 var to   = document.userselect.userselected_list;
 var aList = curList.split(';');
 var i = 0;
 for(i = 0; i < aList.length; i++) {
  var cur = trim(aList[i]);
  var aComp = cur.split(':');
  var type = aComp[0].toUpperCase();
  cur = aComp[0];
  if (aComp.length > 1) cur = type + ":" + aComp[1];
  if (exists(cur, from) || (type == "MAIL")) {
   if (!exists(cur, to)) {
    var text = "";
	if (aComp.length > 1) {

	  if (type == "MAIL") {
	    var fullNm = findName(aComp[1]);
	    if (fullNm == undefined)
	      text = aComp[1];
	    else
	      text = aComp[1] + " (" + fullNm + ") (MAIL)";
	  } else if ((type == "LIST") || (type == "ROLE")) {
	    text = aComp[1] + " (" + type + ")";
	  }
	} else {
		var fullNm = findName(aComp[0]);
		var type = findType(aComp[0]);
		if(type == "INT"){
		text = aComp[0] + "(" + fullNm + ")" + " (INT)";
		}
		if(type == "USER"){
		text = aComp[0] + "(" + fullNm + ")" ;
		}


	}
     if (text != "")
	to.options[to.options.length] = new Option(text, cur);
   }
  }
 }
}

function doGroup(obj) {
 window.focus();
 var theList = new Array();
 var from = document.userselect.userselect_list;
 var mode = obj.options[obj.selectedIndex].value;
 document.userselect.addB.disabled = true;
 document.userselect.removeB.disabled = true;
 // Calculate the list of entries to be displayed
 for(i = 0; i < arrayAll.length; i++) {
  le = arrayAll[i];
  if (mode == "ALL")
   add2Array(theList, le);
  else {
   if (le.type == mode){
    add2Array(theList, le);
   }
  }
 }

 // Remove the current entries
 clearOptions(from);
 for(i = 0; i < theList.length; i++) {
  le = theList[i];
  if (le.type == "USER" || le.type == "INT" )
   optValue = le.value;
  else
   optValue = le.type + ":" + le.value;
  if (le.type == "USER")
   from.options[i] = new Option(le.value +" (" + le.fullName + ")", optValue);
   if (le.type == "MAIL" || le.type == "INT")
    from.options[i] = new Option(le.value +" (" + le.fullName + ")" +" (" + le.type + ")", optValue);
   if(le.type != "USER" && le.type != "MAIL" && le.type != "INT"){
   from.options[i] = new Option(le.value + " (" + le.type + ")", optValue);
  }
 }
}

function doSelectList() {
 document.userselect.userselect_list.value = "";
 document.userselect.addB.disabled = true;
 document.userselect.removeB.disabled = false;
}

function doSelectUser() {
 document.userselect.userselected_list.value = "";
 document.userselect.addB.disabled = false;
 document.userselect.removeB.disabled = true;
}

function doSelectEmail() {
 document.userselect.copytoB.disabled = false;
}
