function getTaskListSortConfig(doSave) {

  var sortNode = configDOM.selectNode("/s");
  if (sortNode == null) {
    sortNode = configDOM.createXMLNode("<s/>");
    configDOM = configDOM.insertNodeInto(configDOM.docNode, sortNode);
    if (doSave) saveTaskListConfig();
  }

  return sortNode;
}

function PageTasks(start) {
 if (start == -1) {
   var pageSize = parent.tasklist.titleBarInfo.endFolder - parent.tasklist.titleBarInfo.startFolder + 1;
   var remainder = parent.tasklist.titleBarInfo.totalFolder % pageSize;
   if (remainder == 0) {
     remainder = pageSize;
   }
   start = parent.tasklist.titleBarInfo.totalFolder - remainder + 1;
 }
 parent.tasklist.location.href = "tasklist.lsw?zFolderStart=" + start;
}

function RefreshFolder(start) {
 PageTasks(start);
}

// dir = 1 is ascending, dir = 0 is descending, dir = -1 is off
// We use short element names because of cookie length limitations
function sortColumn(column) {

  // Clear out current sort icon
  var obj1 = document.getElementById(column + "_ASC");
  var obj2 = document.getElementById(column + "_DESC");
  if (obj1 != null && obj2 != null) {

    loadTaskListConfig();
    var sortNode = getTaskListSortConfig();
    var columnNode = sortNode.selectNode("/c[@id=\""+column+"\"]");
    var dir = 1;
    if (columnNode == null) {
      columnNode = configDOM.createXMLNode("<c id=\""+column+"\" d=\"1\"/>");
      var nodes = sortNode.getElements("c");
      if (nodes.length > 0)
        configDOM = configDOM.insertNodeAfter(nodes[nodes.length-1], columnNode);
      else
        configDOM = configDOM.insertNodeInto(sortNode, columnNode);
    } else {
      dir = columnNode.getAttribute("d") - 1;
      if (dir < -1) dir = 1;
      columnNode.addAttribute("d", dir);
    }
    saveTaskListConfig();

    // We call sortIcon(...) now so that we get immediate feedback, knowing that the
    // sort icons get redisplayed again after the task list is loaded
    sortIcon(column, dir);
  }
}

function sortIcon(column, dir) {
  var obj1 = document.getElementById(column + "_ASC");
  var obj2 = document.getElementById(column + "_DESC");
  if (obj1 != null && obj2 != null) {
    if (dir == "1"){
  	  obj1.style.display = "";
  	  obj2.style.display = "none";
    } else if (dir == "0") {
	  obj2.style.display = "";
	  obj1.style.display = "none";
    } else {
	  obj2.style.display = "none";
	  obj1.style.display = "none";
    }
  }
}

function initSortIcons() {

  loadTaskListConfig();
  var sortNode = getTaskListSortConfig(true);
  var nodes = sortNode.getElements("c");
  for(var i = 0; i < nodes.length; i++)
    sortIcon(nodes[i].getAttribute("id"), nodes[i].getAttribute("d"));
}

function doSort() {
  RefreshFolder(parent.tasklist.titleBarInfo.startFolder);
}

function doSortClear() {

  loadTaskListConfig();
  var sortNode = getTaskListSortConfig();
  var nodes = sortNode.getElements("c");
  for(var i = 0; i < nodes.length; i++)
    sortIcon(nodes[i].getAttribute("id"), -1);

  // "Forget" sort info
  configDOM = configDOM.removeNodeFromTree(sortNode)

  saveTaskListConfig();

  RefreshFolder(parent.tasklist.titleBarInfo.startFolder);
}

function doView(obj) {

  var viewNode = configDOM.selectNode("/v");
  if (viewNode == null) {
    configDOM = configDOM.insertNodeInto(configDOM.docNode, configDOM.createXMLNode("<v/>"));
    viewNode = configDOM.selectNode("/v");
  }
  viewNode.addAttribute("id", obj.value);

  var sortNode = getTaskListSortConfig();
  // "Forget" sort info
  configDOM = configDOM.removeNodeFromTree(sortNode)

  saveTaskListConfig();

  RefreshFolder(parent.tasklist.titleBarInfo.startFolder);
  parent.titlebar.location.href = "tm_titlebar.lsw";
}
