var promptTpl = "The value '{1}' in field {2}";
var requiredTpl = "{1} is blank but must have a value";
var invalidDateTpl = "{1} is not a valid date";
var requiredRadioTpl = "{1} one of the options must be selected";
var requiredCheckboxesTpl = "{1} at least one of the options must be selected";
var integerTpl = "{1} is not an integer";
var numberTpl = "{1} is not valid value. Please enter numeric value";
var decimalTpl = "{1} is not a decimal";
var maxExTpl = "{1} is greater than or equal to the allowed maximum value {2}";
var maxInTpl = "{1} is greater than the allowed maximum value {2}";
var minExTpl = "{1} is less than or equal to the allowed minimum value {2}";
var minInTpl = "{1} is less than the allowed minimum value {2}";
var lengthTpl = "{1} must be {2} characters long";
var minLengthTpl = "{1} must be at least {2} characters long";
var maxLengthTpl = "{1} must be no more than {2} characters long";
var noPatternMatchTpl = "{1} does not match the pattern {2}";
var badScaleTpl = "The scale for field {1} is not equal to {2}";
var badPrecisionTpl = "The precision for field {1} is greater than {2}";
var unrecognizedDateTpl = "Could not recognize the contents of field {1} as a date";
var unrecognizedTimeTpl = "Could not recognize the contents of field {1} as a time";
var monthNames = new Array("jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dec");
var buildMsg_noMessage = "No Message";
var appendMsg_error = "ERROR: ";
var coachDesigner_button_add_new_role = "Add a new row";
var coachDesigner_link_delete = "Delete";
var coachDesigner_link_edit = "Edit";
var coachDesigner_button_postpone = "Postpone";
var coachDesigner_button_ok = "OK";
var coachDesigner_button_show_next_level = "Show next level";

//Get the JS message from the servlet
var jsonResURL = "jsonResBundleLoader?bundle=JavaScriptMessages";

//WLE-7300, add duplicated require(with v7.5 and later coachDesigner.xsl) for backward compatibility of v7.2 coachDesigner.xsl
dojo.require("dojo.number");

try{
dojo.xhrGet( {
    url: jsonResURL,
    handleAs: "json",
    load: function(responseObject, ioArgs) {
		promptTpl = responseObject.validation_promptTpl;
		requiredTpl = responseObject.validation_requiredTpl;
		invalidDateTpl = responseObject.validation_invalidDateTpl;
		requiredRadioTpl = responseObject.validation_requiredRadioTpl;
		requiredCheckboxesTpl = responseObject.validation_requiredCheckboxesTpl;
		integerTpl = responseObject.validation_integerTpl;
		numberTpl = responseObject.validation_numberTpl;
		decimalTpl = responseObject.validation_decimalTpl;
		maxExTpl = responseObject.validation_maxExTpl;
		maxInTpl = responseObject.validation_maxInTpl;
		minExTpl = responseObject.validation_minExTpl;
		minInTpl = responseObject.validation_minInTpl;
		lengthTpl = responseObject.validation_lengthTpl;
		minLengthTpl = responseObject.validation_minLengthTpl;
		maxLengthTpl = responseObject.validation_maxLengthTpl;
		noPatternMatchTpl = responseObject.validation_noPatternMatchTpl;
		badScaleTpl = responseObject.validation_badScaleTpl;
		badPrecisionTpl = responseObject.validation_badPrecisionTpl;
		unrecognizedDateTpl = responseObject.validation_unrecognizedDateTpl;
		unrecognizedTimeTpl = responseObject.validation_unrecognizedTimeTpl;
		buildMsg_noMessage = responseObject.validation_buildMsg_noMessage;
		appendMsg_error = responseObject.validation_appendMsg_error;
		
		coachDesigner_button_add_new_role = responseObject.coachDesigner_button_add_new_role;
		coachDesigner_link_delete = responseObject.coachDesigner_link_delete;
		coachDesigner_link_edit = responseObject.coachDesigner_link_edit;
		coachDesigner_button_postpone = responseObject.coachDesigner_button_postpone;
		coachDesigner_button_ok = responseObject.coachDesigner_button_ok;
		coachDesigner_button_show_next_level = responseObject.coachDesigner_button_show_next_level;
    },
    sync: true
});
}catch(err){
	//call will be failed if no security context, 
	//if do not catch, the failure will block the preview at the AE
	//do nothing at here, the validation messages will be default(en) at this case
}
var message = "";
var msgRegexps = new Array(/\{1\}/,
                           /\{2\}/,
			   /\{3\}/,
			   /\{4\}/);
var dateFormatRegexps = new Array( /yyyy([- \.\/:]|$)/, /MMM([- \.\/:]|$)/, /MM([- \.\/:]|$)/, /M([- \.\/:]|$)/, /dd([- \.\/:]|$)/, /d([- \.\/:]|$)/);
var timeFormatRegexps = new Array( /hh/, /HH/, /mm/, /ss/, /a/, /h/, /H/, /m/);
var whitespace = /^\s*$/;
var digitsRegexp = /^[0-9]+$/;
var integerRegexp = /^\s*(\+|\-)?[0-9]+$/;
var decimalRegexp = /^\s*(\+|\-)?(([0-9]+\.[0-9]*)|([0-9]*\.[0-9]+))$/;
var dateRegexp = /([^- \.\/:]+)[- \.\/:]([^- \.\/:]+)([- \.\/:]([^- \.\/:]+))?/;
var timeRegexp = /^(\d+)([- \.\/:](\d+)([- \.\/:](\d+))?)?$/;
//var timeRegexp = /^([0-1]?[0-9]|2[0-3]):([0-5]?[0-9])(:([0-5]?[0-9]))?$/;
var pmRegexp = /^[pP]\.?[mM]\.?$/;

function buildValidationMsg(field) {
    if(field.zvalmsg != undefined) {
        return field.zvalmsg;
    } else {
        return dijit.byId(field.id).zvalmsg;
    }
}
function buildMsg() {
  if (arguments.length == 0) {
    return buildMsg_noMessage;
  }
  if (arguments.length == 1) {
    return arguments[0];
  }
  var template = arguments[0];
  for (var i = 1; i < arguments.length; ++i) {
    template = template.replace(msgRegexps[i-1], arguments[i]);
  }
  return template;
}
function getPrompt(field) {
  return buildMsg(promptTpl, field.value, field.zprompt);
}
function appendMsg(value) {
  if (message.length > 0) {
    message += "\n";
  } else {
    message = appendMsg_error;
  }
  message += value;
  return false;
}
function issueMessage() {
  if (message.length > 0) {
    setErrorMsg(message);
    message = "";
    return false;
  }
  return true;
}
function defFld(theField, prompt, valmsg, required) {
  theField.zvalidate = true;
  theField.zprompt = prompt;
  theField.zvalmsg = valmsg;
  if (required) {
    theField.zrequired = true;
  }
}

/**
 * Validate value for the given field. 
 * Before validation the field's value is normalized (rounded, if required)
 * @param theField the field to be commited
 * @return the validation error message if validation failed 
 */
function vldFld(theField) {
  if (theField.declaredClass && theField.declaredClass == 'DateTimePicker') {
    if (!theField.isValid()) {
      appendMsg(buildValidationMsg(document.getElementById(theField.id)));
    }
  } else {
    var dijitComponent = dijit.byId(theField.id);
    if(dijitComponent != undefined) {
        fieldMock = {};
        var format = dijitComponent.attr("formatt") || dijitComponent.attr("format");
        if (typeof format == "string") {
            fieldMock.formatt = format;
        }
        fieldMock.basetype = dijitComponent.attr("basetype");
        fieldMock.isnumeric = dijitComponent.attr("isnumeric");
        fieldMock.locale = dijitComponent.attr("locale");
        commitFld(theField, true, fieldMock);
    } else {
        commitFld(theField, true);
    }
  }
  return issueMessage();
}

/**
 * Commit value for the given field. 
 * Before validation the field's value is normalized (f.x., rounded)
 * @param field the field to be commited
 * @param normalize the flag specifying whether the field's value should be normalized
 * @return flag indicating whether the field's value is valid 
 */
function commitFld(field, normalize, fieldMock) {
  // Save original value
  var val = field.value;
  var baseType = Formatter.getFieldBaseType(field);
  if(baseType == undefined && fieldMock != undefined) {
    baseType = fieldMock.basetype;
  }
  var hasFormatted = false;
  var hasChecked = false;
  if (Formatter.isFormattedField(field, fieldMock)) {
    hasFormatted = true;
    var locale = field.getAttribute('locale');
    var format = field.getAttribute('formatt') || field.getAttribute('format');
    if(locale == undefined && fieldMock != undefined) {
        locale = fieldMock.locale;
        format = fieldMock.formatt;
    }
    var f = new Formatter(locale);
    if(baseType=='String'){
		// remove formatting before validation
	    try {
		    Formatter.parseInput(field);
	    } catch (e) {
		}
		var msg = numberTpl.replace(msgRegexps[0], val);
		field.zvalmsg = msg;
		field.value = field.value.replace(/[-,#]/gi,'');
		var isValid = chkTypInteger(field);
    	if (!isValid) {
			 field.value = val;
			 switchToErrorClass(field);
			 return isValid;
		}else {
			field.value = val;
			switchFromErrorClass(field);
	    }
    }
    if (normalize == true) {
      // Reformat the field to force normalization of the value (f.x., rounding for numeric values)
      // Compute validation function for delocalized input and invoke it
      field.value = f.delocalizeInputWithoutCleanup(field.value, format);
      var func = calculateChkFldFunction(field);
      var valid = func(field);
      hasChecked = true;
      if(valid == true){
        var normalizedValue = f.format(field.value, format, true);
        if (normalizedValue != undefined) { // Value is valid
          val = normalizedValue;
          field.setAttribute('delocalized', null);
        }
      }      
    }
  }else if (normalize == true) {
    var locale = field.getAttribute('locale');
    if(locale == undefined && fieldMock != undefined) {
        locale = fieldMock.locale;
    } 
    var f = new Formatter(locale);
    if (baseType == "Integer") {
      // Reformat the field to force rounding for integer value
      field.value = f.delocalizeInputWithoutCleanup(field.value, null);
      var func = calculateChkFldFunction(field);
      var valid = func(field);
      hasChecked = true;
      if(valid == true){
        var normalizedValue = Formatter.formatNumber(field.value, "#");
        if (normalizedValue != undefined) { // Value is valid
          field.value = normalizedValue;
          val = Formatter.formatNumber(field.value, "#,###");
          val = f.localizeOutput(val);
        }
      }
    } 
  } 
  
  // Treating decimal separators for non-formatted fields according to locale
  if (baseType == 'Decimal' && hasFormatted == false) {
    var locale = field.getAttribute('locale');
    if(locale == undefined && fieldMock != undefined) {
        locale = fieldMock.locale;
    }      
    // Compute validation function for delocalized input and invoke it
    field.value = new Formatter(locale).delocalizeInputWithoutCleanup(field.value, null);
    var func = calculateChkFldFunction(field);
    
    var valid = func(field);
    if (valid == true) {
      val = new Formatter(locale).localizeOutputWithGroup(field.value);
    }
  } 
  else {
    if(hasChecked == false){
      var func = calculateChkFldFunction(field);
      var valid = func(field);
    }
  }
  
  // Check for error(s)
  if (!valid) {
    switchToErrorClass(field);
  } else {
    switchFromErrorClass(field);
  }
  
  // Restore localized value
  field.value = val;
  
  return valid;
}

function calculateChkFldFunction(theField) {
  var idPattend = /(.*)_ais_inputfield_/g;
  if (theField.id.match(idPattend))
	  return eval("chkFld_" + RegExp.$1);

  var fieldName = theField.name;
  while (fieldName.indexOf('#') > 0) {
    fieldName = fieldName.replace(/#/, '_');
  }
  fieldName = fieldName.replace(/_\d+_/, '_0_');
  var func = eval("chkFld_" + fieldName);
  return func;
}

function switchToErrorClass(theField) {
  if (theField.id.indexOf("dijit_form_DateTextBox") == 0) {
    theField = dijit.getEnclosingWidget(theField).domNode;
  }
  if (theField.className.indexOf("inputError") < 0) {
    theField.originalClassName = theField.className;
    theField.className = theField.originalClassName + " inputError";
  }
  if(dijit.byId(theField.id) != undefined) {
    // dojo has already set background color and used !important, so need to use inline style with !important instead of class inputError
    dojo.query("#" + theField.id).attr("style", "background-color: #FF8080 !important;");
  }
}

function switchFromErrorClass(theField) {
  if (theField.id.indexOf("dijit_form_DateTextBox") == 0) {
    theField = dijit.getEnclosingWidget(theField).domNode;
  }
  if (theField.className.indexOf("inputError") >= 0) {
    if (theField.originalClassName) {
      theField.className = theField.originalClassName;
    } else {
      theField.className = "";
    }
  }
  if(dijit.byId(theField.id) != undefined) {
    // dojo has already set background color and used !important, so need to use inline style with !important instead of class inputError
    dojo.query("#" + theField.id).attr("style", "");
  }
}

function reformatFld(theField) {
  var func = eval("rfmFld_" + theField.name);
  func(theField);
  if (message.length > 0) {
    switchToErrorClass(theField);
  } else {
    switchFromErrorClass(theField);
  }
  message = "";
  return;
}
function vldForm(theForm) {
    // remove formatting before validation
    try {
        Formatter.toNumbers();
    } catch (e) {
    }
    
  var validatedFields = new Array();
  var valid = true;    

  for (var i = 0; i < theForm.elements.length; ++i) {
    var field = theForm.elements[i];
    var dijitComponent = undefined;
    if(dijit.byId != undefined) {
        dijitComponent = dijit.byId(field.id);
    }
    if(dijitComponent != undefined) {
        field.zvalidate = dijitComponent.attr("zvalidate");
    }
    // Check the date selector input and validate against the dateformat on the widget
    if(field.id.indexOf("DateSelector") >-1 && field.zvalidate) {
      var dojoDateWidget = dijit.byId(field.id);
      if (dojoDateWidget) {
        if(!dojoDateWidget.isValid()) {
          appendMsg(buildMsg(invalidDateTpl, field.zprompt));
        }
        dojoDateWidget.validate(field.zrequired);
      }
    }

    // If it's a hidden field we don't care about it
    if("none" == dojo.style(field)["display"]) {
        continue; 
    }
    if (field.zrequired && !vldRequiredFormFld(field, validatedFields)) {
      valid = false;
    }
    var originalValue = field.value;
    if (field.zvalidate) {
      var baseType = Formatter.getFieldBaseType(field);
      if(dijitComponent != undefined) {
        baseType = dijitComponent.attr("basetype");
      }
     
	  if(Formatter.isFormattedField(field) && baseType=='String'){
		var val = field.value;
		field.value = field.value.replace(/[-,#]/gi,'');
		var msg = numberTpl.replace(msgRegexps[0], val);
		field.zvalmsg = msg;
		valid = chkTypInteger(field);
		if (!valid) {
			 field.value = val;
			 switchToErrorClass(field);
		}else {
			field.value = val;
			switchFromErrorClass(field);
	    }
      }

      if (baseType == 'Integer' || baseType == 'Decimal') {
        var normalizedValue = dojo.number.parse(field.value);
        if (!isNaN(normalizedValue)) {
          field.value = normalizedValue;
        }
      }
      var func = calculateChkFldFunction(field);
      if (!func(field)) {
    	valid = false;    
      }
    }
  }
  
  if (!valid) {
    // restore formatting if form has invalid fields
    Formatter.initFormats();
  }
  
  return issueMessage();
}

/**
 * Commit values of form's input fields.
 * Before submission of a form we need to delocalize values
 * for formatted input fields. If delocalized value is not
 * valid then it is replaced with initial value provided by a coach. 
 *
 * @param form the form to be processed
 * @param fallbackToInitialValueOnError flag specifying whether to restore initial value if value is invalid
 */
function commitFormFields(form, fallbackToInitialValueOnError) {
  var formValid = true; 
  for (var i = 0; i < form.elements.length; ++i) {
    var field = form.elements[i];
    var valid = true;
    if (field.zrequired) {
      if ((field.value == "") ||
          whitespace.test(field.value)) {
        valid = false;
      }
    }
    if (field.zvalidate && (field.getAttribute("formatt") != null || field.getAttribute("format") != null)) {
      Formatter.parseInput(field);
      var func = calculateChkFldFunction(field);
      if (!func(field)) {
        valid = false;
      }
    }
    if (field.zvalidate) {
      var baseType = Formatter.getFieldBaseType(field);
      if (baseType == 'Integer' || baseType == 'Decimal') {
        var normalizedValue = dojo.number.parse(field.value);
        if (!isNaN(normalizedValue)) {
          field.value = normalizedValue;
        }
      }
    }
    if (!valid && fallbackToInitialValueOnError == true &&
      field.getAttribute("initialValue") != null) {
      field.value = field.getAttribute("initialValue");
    }
    formValid = formValid && valid;
  }
  return formValid;
}

/*
 * Validate the given form field defined as 'REQUIRED'.
 * 
 * @param field the field to be validated
 * @param validatedFields the map containing field validation status by field id
 * 
 * @see vldForm(form)
 */
function vldRequiredFormFld(field, validatedFields) {
  if (validatedFields[field.id] != null) {
    return validatedFields[field.id];
  }

  var valid = true;
  var errMsg = null;

  if (field.type == 'radio') {
    // Find all members of the radio button group
    var memberFields = document.getElementsByName(field.name);
    // Determine which member of the group is selected
    var selectedMemberField = null;
    for (var i = 0; i < memberFields.length; i++) {
      var memberField = memberFields[i];
      if (memberField.checked) {
        selectedMemberField = memberField;
      }
    }

    if (selectedMemberField == null) { 
      valid = false;    

//      var controlId = field.getAttribute("name");
//      JR42954: By name, only works for Boolean control, not working for single select. So change to use id instead
//		the radio button group control's children always have group id prefixed.        
      var controlId = field.getAttribute("id");
     
      if (controlId != null) {
    	  var underscoreIndex = controlId.indexOf("_");
          controlId = controlId.substring(0, underscoreIndex);
          
        var groupControl = document.getElementById(controlId);
        if (groupControl != null) { 
        	if (groupControl.zprompt != null) {
        		errMsg = buildMsg(requiredRadioTpl, groupControl.zprompt);
        	} else {
        		errMsg = buildMsg(requiredRadioTpl, getElementName(groupControl));
        	}
        }	
      }
    }
    
    // Register all member of the radio button group as validated (processed)
    // to exclude unnecessary validation of other members of the group.
    for (var i = 0; i < memberFields.length; i++) {
      var memberField = memberFields[i];
      validatedFields[memberField.id] = valid;
    }
  }
  else {
    // if the input field is the multiple selection checkbox
    if (field.type == 'checkbox' && (groupControl = findEnclosingElement(field, 'DIV'))) {
  	  if (/\btwBooleanCheckbox\b/.test(groupControl.className)) {	// for single checkbox
  	    valid = true;
  	  } else if (/\btwMultipleSelect\b/.test(groupControl.className)) { // for multiple selection checkbox
  	    // Find all members of the checkbox group
  	    var fields = dojo.query("input[type='checkbox'][id^='"+groupControl.id+"_']");
  	    valid = false;
  	    dojo.forEach(fields, function(f) {
  	      if (f.checked) {
  	        valid = true;
  	      }
  	    });
  	    if (!valid) {
  	      if (groupControl.zprompt != null) {
  	        errMsg = buildMsg(requiredCheckboxesTpl, groupControl.zprompt);
  	      } else {
  	        errMsg = buildMsg(requiredCheckboxesTpl, getElementName(groupControl));
  	      }
  	    }
  	    dojo.forEach(fields, function(f) { validatedFields[f.id] = valid;});
  	  }
    } else if ( (field.type.toLowerCase() == "select" || field.type.toLowerCase() == "select-multiple") && contains(field.className, "twMultipleSelectLeftList", true) ) {
      valid = true;
    } else if ( (field.type.toLowerCase() == "select" || field.type.toLowerCase() == "select-multiple") && contains(field.className, "twMultipleSelectRightList", true) ) {
      if (field.options.length > 0)
        valid = true;
      else 
        valid = false;
    } else if (field.value == "" || whitespace.test(field.value)) {
      valid = false;
    }
  }

  if (!valid  && field.getAttribute("type") != "hidden") {
    if (errMsg == null) {
      errMsg = buildMsg(requiredTpl, getElementName(field));
    }
    switchToErrorClass(field);
    appendMsg(errMsg);
  } else {
    switchFromErrorClass(field);
  }

  return valid;
}

function contains(string,substr,isIgnoreCase) {
	if(isIgnoreCase) {
		string = string.toLowerCase();
		substr = substr.toLowerCase();
	}
	var startChar = substr.substring(0,1);
	var strLen = substr.length;
	for(var j = 0; j < string.length-strLen + 1; j++) {
		if(string.charAt(j) == startChar) {
			if(string.substring(j,j+strLen) == substr) {
				return true;
			}  
		}
	}
	return false;
}

/**
 * Resolves element name by its label. If label is not present
 * default value from field.zprompt is used
 * @param field field
 * @return element name
 */
function getElementName(field) {
	var labelElementId = field.id + '_Label';
	if (field.type == 'checkbox' && field.id.substr(-9) == '_checkbox') {
		labelElementId = field.id.substr(0, field.id.length-9) + '_Label';
	}
	var labelText = getLabelTextIfExists(labelElementId);
	if (labelText != null)
		return labelText;
	
	// JR42954: handling controls in the table
	var tableElename = getTableElementName(field);
	if (tableElename != null) 
		return tableElename;
	
	
	if (field.zprompt != null)
		return field.zprompt;
	return "Field";
}

//Added in JR42954
function getTableElementName(field) {
	var cellIndex = getCellIndex(field);
	//Need to get td element
	var tdElement = getTDElement(field);
	// Need to check if control in the table by the class name (twTableTD)
	if (tdElement != undefined && cellIndex != undefined) {
		// Get label from sibling td element
		if (tdElement.className.toUpperCase().indexOf("twTableTD".toUpperCase()) < 0) {
			var trElement = getTableRowElement(tdElement.parentElement);
			if (cellIndex-1 >= 0) {
				if (trElement.cells[cellIndex-1] != undefined && trElement.cells[cellIndex-1].children[0] != undefined) {
					if (trElement.cells[cellIndex-1].children[0].childNodes[0] != undefined && trElement.cells[cellIndex-1].children[0].childNodes[0].nodeValue != undefined) {
						return trElement.cells[cellIndex-1].children[0].childNodes[0].nodeValue;
					}
				} else {
					return "Untitled field: ";
				}
			} else {
				//No label field
				return "Untitled field: ";
			}
		} else {
		// in the table, get the label from header row
		
			var tbodyElement = getTableBody(tdElement.parentElement);
			if (tbodyElement != undefined && tbodyElement.children[0] != undefined && tbodyElement.children[0].cells[cellIndex] != undefined ) {
				if (tbodyElement.children[0].cells[cellIndex].children[0] != undefined && tbodyElement.children[0].cells[cellIndex].children[0].innerHTML != "" ) {
					return tbodyElement.children[0].cells[cellIndex].children[0].innerHTML;
				}else {
					return "Untitled field: ";
				}
			} 
		}
	}	
}

function getTDElement(field) {
	if (field.tagName.toUpperCase() == "td".toUpperCase()) {
		return field;
	} else {
		return getTDElement(field.parentElement)
	}
	
}


function getTableBody(field) {
	if (field.tagName.toUpperCase() == "tbody".toUpperCase()) {
		return field;
	} else {
		return getTableBody(field.parentElement)
	}
		
}

function getTableRowElement(field) {
	if (field.tagName.toUpperCase() == "tr".toUpperCase()) {
		return field;
	} else {
		return getTableRowElement(field.parentElement)
	}
		
}
function getCellIndex (field) {
	if (field.cellIndex != undefined) {
		return field.cellIndex;
	} else {
		return getCellIndex(field.parentElement);
	}
}


/**
 * Retrieves label text by label id
 * @param labelId label id
 * @return label text or null if label does not exist
 */
function getLabelTextIfExists(labelId) {
	var element = document.getElementById(labelId);
	if (element != null) { 
	  if (element.childNodes[0] != null && element.childNodes[0].nodeValue != null) {
		return element.childNodes[0].nodeValue;
	  }
	}
	return null;
}

function chkTypInteger(field) {
  if (!whitespace.test(field.value) &&
      !integerRegexp.test(field.value)) {
    return appendMsg(buildValidationMsg(field));
  }
  return true;
}
function chkTypDecimal(field) {
  if (!whitespace.test(field.value) &&
      !integerRegexp.test(field.value) &&
      !decimalRegexp.test(field.value)) {
    return appendMsg(buildValidationMsg(field));
  }
  return true;
}
function chkMaxEx(field, maxValue) {
  if (field.value >= maxValue) {
    return appendMsg(buildValidationMsg(field));
  }
  return true;
}
function chkMaxIn(field, maxValue) {
  if (field.value > maxValue) {
    return appendMsg(buildValidationMsg(field));
  }
  return true;
}
function chkMinEx(field, minValue) {
  if (field.value <= minValue) {
    return appendMsg(buildValidationMsg(field));
  }
  return true;
}
function chkMinIn(field, minValue) {
  if (field.value < minValue) {
    return appendMsg(buildValidationMsg(field));
  }
  return true;
}
function chkLength(field, length) {
  if (!whitespace.test(field.value) &&
      (field.value.length != length)) {
      return appendMsg(buildValidationMsg(field));
  }
  return true;
}
function chkMinLength(field, length) {
  if (!whitespace.test(field.value) &&
      (field.value.length < length)) {
    return appendMsg(buildValidationMsg(field));
  }
  return true;
}
function chkMaxLength(field, length) {
  if (!whitespace.test(field.value) &&
      (field.value.length > length)) {
    return appendMsg(buildValidationMsg(field));
  }
  return true;
}
function chkPattern(field, pattern) {
  if (!whitespace.test(field.value) &&
      !pattern.test(field.value)) {
    return appendMsg(buildValidationMsg(field));
  }
  return true;
}
function chkPrecision(field, precision) {
  var value = field.value;
  if (whitespace.test(value))
    return true;
  if ((value.charAt(0) == '+') || (value.charAt(0) == '-')) {
    value = value.substr(1);
  }
  var len = value.length;
  if (value.indexOf('.') >= 0) {
     len = len - 1;
  }
  if (len != precision) {
    return appendMsg(buildValidationMsg(field));
  } else {
    return true;
  }
}
function chkScale(field, scale) {
  var value = field.value;
  if (whitespace.test(value))
    return true;
  if ((value.charAt(0) == '+') || (value.charAt(0) == '-')) {
    value = value.substr(1);
  }
  var i = value.indexOf('.');
  if (i < 0) {
    if (scale == 0) {
      return true;
    } else {
      return appendMsg(buildValidationMsg(field));
    }
  } else {
    var right = value.length - i - 1;
    if (right == scale) {
      return true;
    } else {
      return appendMsg(buildValidationMsg(field));
    }
  }
}
function chkTime(field, fmt) {
  var ts = field.value;
  if (whitespace.test(ts))
    return true;
  while(ts.charAt(0) == " ") {
    ts = ts.substring(1);
  }
  while(ts.charAt(ts.length-1) == " ") {
    ts = ts.substring(0, ts.length-1);
  }

  if (!timeRegexp.test(ts))
    return appendMsg(buildValidationMsg(field));

  var today = new Date();
  var h = RegExp.$1;
  var hh = h;
  var m = RegExp.$3;
  var s = RegExp.$5;

  if (h == 24)
	return appendMsg(buildValidationMsg(field));
  if (h <= 12) {
    if (pmRegexp.test(ts))
      hh = h + 12;
  } else {
      h = h - 12;
  }
  if ((h > 12) || (h < 0)) {
    return appendMsg(buildValidationMsg(field));
//    hh = today.getHours();
//    if (hh > 12)
//       h = hh - 12;
//    else
//       h = hh;
  }

  var ampm = 'AM';
  if (hh > 12) {
    ampm = 'PM';
  }

// If no minutes are entered then use 0
// we used to use the current number of minutes
  if (!m || (m > 59))
//    m = 0;
    return appendMsg(buildValidationMsg(field));

  if (s > 59) 
    return appendMsg(buildValidationMsg(field));

// If no seconds are entered then use 0
// we used to use the current number of seconds
  if (!s || (s > 59))
    s = "00";

  field.value = formatTime(fmt,
                           padToTwoDigits(h), padToTwoDigits(hh), padToTwoDigits(m),
                           s, ampm,
                           h, hh, m);
  return true;
}
function formatTime() {
  var fmt = arguments[0];
  for (var i = 1; i < arguments.length; ++i) {
    fmt = fmt.replace(timeFormatRegexps[i - 1], arguments[i]);
  }
  return fmt;
}
function chkDate(field, fmt) {
  var ds = field.value;
  if (whitespace.test(ds))
    return true;
  // strip leading and trailing space
  while(ds.charAt(0) == " ") {
    ds = ds.substring(1);
  }
  while(ds.charAt(ds.length-1) == " ") {
    ds = ds.substring(0, ds.length-1);
  }

  var today = new Date();
  var dd = 0;
  var mm = 0;
  var yy = (today.getYear() < 1900) ? today.getYear() + 1900 : today.getYear();

  if ((ds == "t") || (ds == "today")) {  
    dd = today.getDate();
    mm = today.getMonth() + 1;
    ds = reformatYearMonthDay(yy, mm, dd);
  } else if ((ds.length < 3) && digitsRegexp.test(ds)) {  
    // try as a day in the current month and year
    if (parseInt(ds,10) < 32) {
      dd = ds;
      mm = today.getMonth() + 1;
      ds = reformatYearMonthDay(yy, mm, dd);
    }
  } else if ((ds.length == 3) && (monthNumber(ds) > 0)) {  
    // assume it's a month string, set day to 1st
    dd = 1;
    mm = monthNumber(ds);
    ds = reformatYearMonthDay(yy, mm, dd);
  } else if (dateRegexp.test(ds)) {  
    var p1 = RegExp.$1;
    var p2 = RegExp.$2;
    var p3 = RegExp.$4;
    // Try first to find the day month and year in the order
    // they are in the requested format
    var dayPos = fmt.indexOf("d");
    var monthPos = fmt.indexOf("M");
    var yearPos = fmt.indexOf("y");
    var validated = false;
    if (dayPos < monthPos) {
       if (yearPos < dayPos) {
          if (isYearDayMonth(p1, p2, p3, yy)) {
             ds = reformatYearDayMonth(p1, p2, p3, yy);
             validated = true;
          }
       } else if (monthPos < yearPos) {
          if (isDayMonthYear(p1, p2, p3, yy)) {
             ds = reformatDayMonthYear(p1, p2, p3, yy);
             validated = true;
          } 
       } else {
          if (isDayYearMonth(p1, p2, p3, yy)) {
             ds = reformatDayYearMonth(p1, p2, p3, yy);
             validated = true;
          } 
       }
    } else {
       if (yearPos < monthPos) {
          if (isYearMonthDay(p1, p2, p3, yy)) {
             ds = reformatYearMonthDay(p1, p2, p3, yy);
             validated = true;
          } 
       } else if (dayPos < yearPos) {
          if (isMonthDayYear(p1, p2, p3, yy)) {
             ds = reformatMonthDayYear(p1, p2, p3, yy);
             validated = true;
          } 
       } else {
          if (isMonthYearDay(p1, p2, p3, yy)) {
             ds = reformatMonthYearDay(p1, p2, p3, yy);
             validated = true;
          }          
       }
    }

    // if the requested format didn't work try others in order
    if (!validated) {
      if (isMonthDayYear(p1, p2, p3, yy))
        ds = reformatMonthDayYear(p1, p2, p3, yy);
     else if (isDayMonthYear(p1, p2, p3, yy))
        ds = reformatDayMonthYear(p1, p2, p3, yy);
      else if (isYearMonthDay(p1, p2, p3, yy))
        ds = reformatYearMonthDay(p1, p2, p3, yy);
      else if (isYearDayMonth(p1, p2, p3, yy))
        ds = reformatYearDayMonth(p1, p2, p3, yy);
      else
        return appendMsg(buildValidationMsg(field));
    }

  } else {  
      return appendMsg(buildValidationMsg(field));
  }

  dateRegexp.test(ds);
  year = RegExp.$1;
  month = RegExp.$2;
  day = RegExp.$4;

  // Need to check for a valid date (eg: 02/31/2001 is not). The Javascript Date
  // object will wrap to the next month if the day is invalid for a particular month. We
  // just compare our month with the Date objects and if they are not the same then
  // bingo....
  dateObj = new Date(year, month - 1, day);
  if (dateObj.getMonth() != (month - 1))
    return appendMsg(buildValidationMsg(field));
  field.value = formatDate(fmt, year, monthName(month), padToTwoDigits(month), month, padToTwoDigits(day), day);

  return true; 
}
function isMonthDayYear(mm, dd, yy, year) {
  return isYearMonthDay(yy, mm, dd, year);
}
function reformatMonthDayYear(mm, dd, yy, year) {
  return reformatYearMonthDay(yy, mm, dd, year);
}
function isMonthYearDay(mm, yy, dd, year) {
  return isYearMonthDay(yy, mm, dd, year);
}
function reformatMonthYearDay(mm, yy, dd, year) {
  return reformatYearMonthDay(yy, mm, dd, year);
}
function isDayMonthYear(dd, mm, yy, year) {
  return isYearMonthDay(yy, mm, dd, year);
}
function reformatDayMonthYear(dd, mm, yy, year) {
  return reformatYearMonthDay(yy, mm, dd, year);
}
function isDayYearMonth(dd, yy, mm, year) {
  return isYearMonthDay(yy, mm, dd, year);
}
function reformatDayYearMonth(dd, yy, mm, year) {
  return reformatYearMonthDay(yy, mm, dd, year);
}
function isYearDayMonth(yy, dd, mm, year) {
  return isYearMonthDay(yy, mm, dd, year);
}
function reformatYearDayMonth(yy, dd, mm, year) {
  return reformatYearMonthDay(yy, mm, dd, year);
}
function isYearMonthDay(yy, mm, dd, year) {
  if (!digitsRegexp.test(mm))
    mm = monthNumber(mm);
  if ((mm < 1) || (mm > 12))
    return false;
  if (yy == "")
    yy = year;
  else if (!digitsRegexp.test(yy))
    return false;
  // Restrict year to four or less digits
  if (yy > 9999)
    return false;
  if (!digitsRegexp.test(dd))
    return false;
  if ((dd < 1) || (dd > 31))
    return false;
  return true;
}
function reformatYearMonthDay(yy, mm, dd, year) {
  if (!digitsRegexp.test(mm))
    mm = monthNumber(mm);
  if (yy == "")
    yy = year;
  if (yy < 100)
    yy = 2000 + parseInt(yy,10);
  return yy + "." + mm + "." + dd;
}
function formatDate() {
  var fmt = arguments[0];
  for (var i = 1; i < arguments.length; ++i) {
    fmt = fmt.replace(dateFormatRegexps[i - 1], arguments[i] + "$1");
  }
  return fmt;
}
function monthNumber(m) {
  if (m.length > 3)
    m = m.substring(0, 2);
  m = m.toLowerCase();
  for (var i = 0; i < monthNames.length; ++i) {
    if (monthNames[i] == m)
      return i + 1;
  }
  return 0;
}
function monthName(m) {
  var monthName = monthNames[m - 1];
  return (monthName.charAt(0).toUpperCase() + monthName.substr(1));
}
function padToTwoDigits(n) {
  if (n.toString().length < 2)
    return "0" + n.toString();
  else
    return n;
}